require "import"
import "android.app.NotificationManager"
import "android.content.Context"
import "android.media.AudioManager"
import "android.content.Intent"

context = activity or service
audioManager = context.getSystemService(Context.AUDIO_SERVICE)
notificationManager = context.getSystemService(Context.NOTIFICATION_SERVICE)

function getPhoneMode()
  local mode = audioManager.getRingerMode()
  if mode == AudioManager.RINGER_MODE_SILENT then
    return "Silent"
  elseif mode == AudioManager.RINGER_MODE_VIBRATE then
    return "Vibrate"
  elseif mode == AudioManager.RINGER_MODE_NORMAL then
    return "Normal"
  else
    return "Unknown"
  end
end

function requestDoNotDisturbPermissions()
  -- اطلب إذن من المستخدم لتغيير وضع عدم الإزعاج
  if not notificationManager.isNotificationPolicyAccessGranted() then
    local intent = Intent("android.settings.NOTIFICATION_POLICY_ACCESS_SETTINGS")
    intent.addFlags(Intent.FLAG_ACTIVITY_NEW_TASK)
    context.startActivity(intent)
  end
end

function togglePhoneMode()
  if not notificationManager.isNotificationPolicyAccessGranted() then
    requestDoNotDisturbPermissions()
    service.postSpeak(500, "Permission needed for Do Not Disturb access")
    return
  end

  local currentMode = audioManager.getRingerMode()
  if currentMode == AudioManager.RINGER_MODE_NORMAL then
    audioManager.setRingerMode(AudioManager.RINGER_MODE_VIBRATE)
  elseif currentMode == AudioManager.RINGER_MODE_VIBRATE then
    audioManager.setRingerMode(AudioManager.RINGER_MODE_SILENT)
  else
    audioManager.setRingerMode(AudioManager.RINGER_MODE_NORMAL)
service.playSoundTick()
  end
end

local phoneMode = getPhoneMode()

-- Example usage:
-- To toggle phone mode between Normal, Vibrate, and Silent
togglePhoneMode()